码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 3853 LOOPS(概率dp求期望啊)

时间:2015-02-05 21:57:14      阅读:190      评论:0      收藏:0      [点我收藏+]

标签:hdu   dp   期望   

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3853


Problem Description
Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl).

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS.
技术分享

The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)!
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS.




 

Input
The first line contains two integers R and C (2 <= R, C <= 1000).

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces.

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them).

You may ignore the last three numbers of the input data. They are printed just for looking neat.

The answer is ensured no greater than 1000000.

Terminal at EOF


 

Output
A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS.

 

Sample Input
2 2 0.00 0.50 0.50 0.50 0.00 0.50 0.50 0.50 0.00 1.00 0.00 0.00
 

Sample Output
6.000
 

Source

题意:

有一个人被困在一个 R*C(2<=R,C<=1000) 的迷宫中;

最开始他在点 (1,1) ,迷宫的出口是 (R,C)。在迷宫的每一个格子中,他每启一个传送通道需花费 2 个魔法值。假设他在 (x,y) 这个格子中,开启传送通道之后,有 p_loop[i][j] 的概率被送到 (x,y),p_lift[i][j] 的概率被送到 (x,y+1),有 p_down[i][j] 的概率被送到 (x+1,y)

问他到出口需要花费的魔法值的期望是多少?

PS:

求期望逆推!

代码如下:

#include <cstdio>
#include <cstring>
#define maxn 1017
double go[maxn][maxn][3];
double dp[maxn][maxn];
//dp[i][j] = go[i][j][0]*dp[i][j]+go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2;
//走到下一步消耗2魔法值,所以加2
//移项得:dp[i][j] = (go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2)/(1.0-go[i][j][0]);
int main()
{
    int r, c;
    while(~scanf("%d%d",&r,&c))
    {
        for(int i = 1; i <= r; i++)
        {
            for(int j = 1; j <= c; j++)
            {
                for(int k = 0; k < 3; k++)
                {
                    scanf("%lf",&go[i][j][k]);
                }
            }
        }
        dp[r][c] = 0;
        for(int i = r; i >= 1; i--)
        {
            for(int j = c; j >= 1; j--)
            {
                if(i==r && j==c)
                    continue;
                if(go[i][j][0] == 1)//停留在原地的概率为1
                    continue;
                dp[i][j] = (go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2)/(1.0-go[i][j][0]);
            }
        }
        printf("%.3lf\n",dp[1][1]);
    }
    return 0;
}


HDU 3853 LOOPS(概率dp求期望啊)

标签:hdu   dp   期望   

原文地址:http://blog.csdn.net/u012860063/article/details/43536213

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!